mod Mrd

incl Mtex

incl Mtexrc

incl Mtexgr

incl Maux

incl Mxgrf

rem 
  \para \bf  Partial Recursive Functions.  \end 

rem 
  \para \bf  Arithmetization of computation model.  \end 

rem 
  \para \it  Codes of numerals.  \end 

fun Cnm 'Tex_f1_gr_cnm'
  Cnm(0) = Zt
  Cnm(x+1) = St Cnm(x)

rem 
  \para \it  Substitution function.  \end 

fun/3 Sb 'Tex_f3_gr_sb'
  Sb(Vt(i),e,rs) = Sub(rs,i-1)
  Sb(Zt,e,rs) = Zt
  Sb(St(t),e,rs) = St Sb(t,e,rs)
  Sb(Pt(t),e,rs) = Pt Sb(t,e,rs)
  Sb(Dt(t1,t2,t3),e,rs) = Dt(Sb(t1,e,rs),Sb(t2,e,rs),Sb(t3,e,rs))
  Sb(Act(t1,t2),e,rs) = Cntr(Sb(t1,e,rs),Sb(t2,e,rs))
  Sb(Apt(Fs(n),ts),e,rs) = Apt(e,ts)
  Sb(Apt(Ls(n,t),ts),e,rs) = Apt(Ls(n,t),ts)

rem 
  \para \it  Auxiliary functions.  \end 

fun Pn 
  Pn(Zt) = Zt
  Pn St(t) = t

fun/3 Dn 
  Dn(Zt,t2,t3) = t3
  Dn(St(t1),t2,t3) = t2

rem 
  \para \it  One-step reduction function.  \end 

fun Rd 
  Rd(Zt) = Zt
  Rd St(t) = St Rd(t)
  Rd Pt(t) = Pn(t) <- Nm(t)
  Rd Pt(t) = Pt Rd(t) <- ~Nm(t)
  Rd Dt(t1,t2,t3) = Dn(t1,t2,t3) <- Nm(t1)
  Rd Dt(t1,t2,t3) = Dt(Rd(t1),t2,t3) <- ~Nm(t1)
  Rd Act(t1,t2) = Cntr(t1,Rd(t2)) <- Is_apt(t1)
  Rd Act(t1,t2) = Cntr(Rd(t1),t2) <- ~Is_apt(t1)
  Rd Apt(Ls(n,t),ts) = Sb(t,Ls(n,t),ts)

